<script src="../store/index.js"></script>
<template>
    <v-container>
        <v-container>
            <v-card class="px-3">
                <v-card-text class="headline">Search Plan</v-card-text>
                <v-card-text class="mt-0 pt-0">
                    <v-row>
                        <v-text-field
                                height="50"
                                background-color="color"
                                label="Solo"
                                placeholder="Search"
                                solo
                        ></v-text-field>
                        <v-btn color="orange darken-1" height="50" dark>Search</v-btn>
                    </v-row>
                </v-card-text>
            </v-card>
        </v-container>
        <v-container>
            <v-list-item
                    v-for="(plan, index) in pagination.data"
                    :key="index"
            >
                <v-list-item-content two-line class="text-left">
                    <v-row>
                        <v-col class="text-center">
                            <v-list-item-title class="pa-1 title">{{plan.title}}</v-list-item-title>
                        </v-col>
                        <v-col class="text-center">
                            <v-list-item-title class="pa-1 title">Scale: {{plan.scale}}</v-list-item-title>
                        </v-col>
                        <v-col class="text-center">
                            <v-btn text class="float-right pa-1 caption primary" @click="viewPlan(plan.id)">View More
                            </v-btn>
                        </v-col>
                    </v-row>
                </v-list-item-content>
                <br>
            </v-list-item>
            <v-row class="fill-height" align="end" justify="center">
                <v-col cols="8">
                    <v-container class="max-width">
                        <v-pagination
                                v-model="page"
                                class="my-4"
                                :length="this.pagination['last_page']"
                        ></v-pagination>
                    </v-container>
                </v-col>
            </v-row>
        </v-container>
        <v-dialog v-model="planDialog" max-width="500">
            <v-card>
                <v-card-title>{{selectedPlan.title}}</v-card-title>
                <v-card-text class="text-left">Scale: {{selectedPlan.scale}}</v-card-text>
                <v-card-text v-if="selectedPlanItineraries.itineraryable !== null">
                    <v-timeline>
                        <v-timeline-item
                                v-for="(itinerary, index) in selectedPlanItineraries"
                                :key="index"
                                color="red lighten-2"
                                large
                        >
                            <template v-slot:opposite>
                                <span>{{itinerary.itineraryable.name}}</span>
                            </template>
                            <v-card class="elevation-2">
                                <v-card-title class="headline">{{itinerary.itineraryable.name}}</v-card-title>
                                <v-card-text>
                                    {{itinerary.itineraryable.location}}
                                </v-card-text>
                            </v-card>
                        </v-timeline-item>
                    </v-timeline>
                </v-card-text>
                <v-card-text v-if="selectedPlanItineraries.itineraryable === null">
                    <span>Not Itineraryable</span>
                </v-card-text>
                <v-card-text>
                    <v-row>
                        <v-chip v-for="(tag, index) in selectedPlan.tags"
                                :key="index" class="ma-2"
                        >
                            {{tag.name}}
                        </v-chip>
                    </v-row>
                </v-card-text>
            </v-card>
        </v-dialog>
    </v-container>
</template>

<script>
    export default {
        name: "Plan",
        data() {
            return {
                page: 1,
                pagination: Object,
                selectedPlan: Object,
                selectedPlanItineraries: [],
                planDialog: false,
            }
        },
        watch: {
            page: function () {
                this.getPlans()
            }
        },
        methods: {
            changeLoading() {
                this.$emit('isLoading')
            },
            getPlans() {
                this.changeLoading()
                this.$store.dispatch('listPlan', this.page).then(response => {
                    this.pagination = response.data.data.plans
                }).catch((error) => {
                    console.log(error)
                }).finally(() => {
                    this.changeLoading()
                })
            },
            viewPlan(planId) {
                this.changeLoading()
                this.$store.dispatch('viewPlan', planId).then(response => {
                    this.selectedPlan = response.data.data.plan
                    this.selectedPlanItineraries = response.data.data.itineraries
                    this.planDialog = true
                    console.log(this.selectedPlan)
                    console.log(this.selectedPlanItineraries)
                }).catch((error) => {
                    console.log(error)
                }).finally(() => {
                    this.changeLoading()
                })
            }
        },
        created() {
            this.getPlans()
        }
    }
</script>

<style scoped>

</style>